#define TOTAL_TEXTURES		18
#define FONT_TEXTURE		0
#define GROUND_TEXTURE		1
#define MINE_TEXTURE		2
#define BRICK1_TEXTURE		3
#define BRICK0_TEXTURE		4
#define TRUNK_TEXTURE		5
#define TREE_TEXTURE		6
#define REDTANK_TEXTURE		7
#define BLUETANK_TEXTURE	8
#define DEBRIS_TEXTURE		9
#define WALL_TEXTURE		10
#define MISSLE_TEXTURE		11
#define SMOKE_TEXTURE		12
#define LIFE_POWERUP_TEXTURE	13
#define BRICK_POWERUP_TEXTURE	14
#define MINE_POWERUP_TEXTURE	15
#define MISSLE_POWERUP_TEXTURE	16
#define GRENADE_POWERUP_TEXTURE	17

#define TOTAL_MODELS	1
#define TANK_MODEL		0

#define EMPTY			0
#define MINE			1
#define BRICK1			2
#define BRICK0			3
#define TREE			4
#define TRUNK			5
#define BLUEFLAG		6
#define REDFLAG			7
#define BLUEGATE		8
#define REDGATE			9
#define LIFE_POWERUP	10
#define BRICK_POWERUP	11
#define MINE_POWERUP	12
#define MISSLE_POWERUP	13
#define GRENADE_POWERUP	14

#define BRICK_MODE		0
#define MINE_MODE		1
#define MISSLE_MODE		2
#define GRENADE_MODE	3

#define PI 3.1415926535897932384626433832795

#include <windows.h>		// Header File For Windows
#include <gl\gl.h>			// Header File For The OpenGL32 Library
#include <gl\glu.h>			// Header File For The GLu32 Library
#include <gl\glaux.h>		// Header File For The Glaux Library

int InitGL(GLvoid);
int DrawGLScene(GLvoid);
AUX_RGBImageRec *LoadBMP(char *Filename);
int LoadGLTextures(void);
GLvoid BuildFont(GLvoid);
GLvoid glPrint(GLint x, GLint y, int set, const char *fmt, ...);

BOOL CreateGLWindow(char* title, int width, int height, int bits, bool fullscreenflag);
GLvoid KillGLWindow(GLvoid);

int gamestart(void);
void playintro(void);
void gameinit(void);
void maingame(void);
void calclightmap(void);

struct _2Df
{
	float x;
	float y;
};

struct _2Di
{
	int x;
	int y;
};

struct _3Df
{
	float x;
	float y;
	float z;
};

struct c_controls
{
	int forward;
	int backward;
	int left;
	int right;

	int fire;
	int leftchange;
	int rightchange;

	int leftf;
	int rightf;
};	

struct c_ammo
{
	int bricks;
	int mines;
	int missles;
	int grenades;
};

struct c_player
{
	_2Df pos;
	int rot;

	c_ammo ammo;

	_2Di startpos;
	_2Di buildpos;

	int missleload;
	int grenadeload;

	int lives;
	int rebirth;

	c_controls control;
	int mode;
};

struct c_explosion
{
	_2Di pos;
	int stage;
};

struct c_missle
{
	_2Df pos;
	int rot;

	_2Di start;

	unsigned int smoke;
	
	int active;
};

struct c_smoke
{
	_2Df pos;
	int rot;

	int life;
	int stillmoving;

	int length;
	
	int active;
};

struct c_grenade
{
	_2Di pos;
	
	int stage;
};

struct c_particle
{
	int life;

	_3Df pos;
	_3Df dir;
};

struct c_debris
{
	int active;
	_3Df pos;
	_3Df dir;

	_3Df color;
};

struct c_rain
{
	_3Df pos;
};